unit Unit1;
{ (c) Epsylon Technologies 1996

 mailto  : dima@demo.ru
 web     : http://ib.demo.ru
 listserv: ib@demo.ru }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, IBPROC32, Buttons;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    LTF: TLabel;
    LMW: TLabel;
    LPR: TLabel;
    LPW: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    eDBName: TEdit;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    ConnectBtn: TBitBtn;
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ReadAllInfo;
  end;

var
  MainForm: TMainForm;
  LibHandle :THandle; { handle of GDS32.DLL - InterBase API }

const
 dbHandle : isc_db_handle = 0;

implementation uses Unit2;

{$R *.DFM}

var
 ISCDatabaseInfo  : TISCDatabaseInfo;
 ISCAttachDatabase: TISCAttachDatabase;
 ISCDetachDatabase: TISCDetachDatabase;

{   isc_database_info   
 ,    isc_info_end

There must be an array created before call to isc_database_info,
and array must be ended by isc_info_end flag }

const AllInfo : array [0..4] of byte = (isc_info_fetches,
                                       isc_info_marks,
                                       isc_info_reads,
                                       isc_info_writes,
                                       isc_info_end);

procedure TMainForm.ReadAllInfo;
 var
  pnum: word;    {parameter type /      }
  pvar: integer; {statistics value /  , .   }
  pc: PChar;
  rlen: word;
  rbuf: array [0..512] of byte; { output buffer /      }
  stat: isc_status;
  sv: status_vector;
 begin
  rlen:=SizeOf(rbuf);
  { call function to get info /       }
  stat:=ISCDatabaseInfo(@sv, @dbhandle, SizeOf(allinfo), @allinfo, rlen, @rbuf);

  pc:=@rbuf;

  while pc[0] <> char(isc_info_end) do
    begin
      pnum:=byte(pc[0]); Inc(pc); { parameter type byte /    }
      rlen:=word(pc[0]); Inc(pc, 2); { word of parameter length /     }
      Move(pc[0], pvar, SizeOf(pvar));
      case pnum of
        isc_info_fetches        : Label4.Caption:=Format(': %d', [pvar]);
        isc_info_marks          : Label5.Caption:=Format(': %d', [pvar]);
        isc_info_reads          : Label6.Caption:=Format(': %d', [pvar]);
        isc_info_writes         : Label7.Caption:=Format(': %d', [pvar]);
      end;
      Inc(pc, rlen);
    end;


 end;


procedure TMainForm.Timer1Timer(Sender: TObject);
begin
 ReadAllInfo;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
   eDBName.Text:=OpenDialog1.FileName;
end;

procedure TMainForm.ConnectBtnClick(Sender: TObject);
var
  stat: isc_status;
  sv: status_vector;
  L: TLoginForm;
  dpb: string;
  username: string;
  password: string;
  dbname: string;
  fdpb: pchar;
begin
  Timer1.Enabled:=False;

  { close database if it was open }
  if integer(dbhandle) <> 0 then
    begin
      stat:=ISCDetachDatabase(@sv, @dbhandle);
      connectBtn.Kind:=bkOK;
      connectBtn.Caption:='Connect';
      Exit;
    end;


  { get username and password }
  L:=TLoginForm.Create(Application);
  if L.ShowModal = mrOk then
    begin
      username:=L.eUserName.Text;
      password:=L.ePassword.Text;
      L.Free;
    end
  else
    begin
      L.Free;
      Exit;
   end;


  { fill dpb }
  dbhandle:=0;
  dbname:=eDBName.Text;
  dpb:=char(isc_dpb_version1);
  dpb:=dpb + char(isc_dpb_user_name) + Char(Length(username)) + username;
  dpb:=dpb + char(isc_dpb_password) + Char(Length(password)) + password;

  { try to open database }
  stat:=ISCAttachDatabase(@sv, Length(dbname), pchar(dbname), @dbhandle, Length(dpb), pchar(dpb));

  { handle some known errors }
  case stat of
    0        : ;
    335544344: raise Exception.Create('Can''t open database ' + dbname);
    335544472: raise Exception.Create('Invalid username or password!');
  else
    raise Exception.Create('Error opening database. code=' + IntToStr(stat));
  end;

(*  This code was used when connection was made by BDE's
  TDatabase component.

  Database1.Close;
  Database1.Params.Values['SERVER NAME']:=Edit1.Text;
  Database1.Open;
  { get database native handle /  native handle  }
  Check( DbiGetProp( HDBIOBJ(Database1.Handle), dbNATIVEHNDL,
                     @dbhandle, sizeof( isc_db_handle), rlen)); *)

  connectBtn.Kind:=bkCancel;
  connectBtn.Caption:='Disconnect';

  Timer1.Enabled:=True;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.HintColor:=clAqua;
  eDBName.Hint:='enter full database path.'+#10#13+
                '  tcp/ip    server:c:\dir\data.gdb'+#10#13+
                '  netbeui \\server\c:\dir\data.gdb';

 { load IB API }
 LibHandle := LoadLibrary('gds32.dll');
 if LibHandle < 32 then
   raise Exception.Create('Unable to load gds32.dll');

  @IscDatabaseInfo := GetProcAddress(LibHandle, 'isc_database_info');
  if @IscDatabaseInfo = nil then
    raise Exception.Create('Failed to lookup isc_database_info');

  @IscAttachDatabase := GetProcAddress(LibHandle, 'isc_attach_database');
  if @IscAttachDatabase = nil then
    raise Exception.Create('Failed to lookup isc_attach_database');

  @IscDetachDatabase := GetProcAddress(LibHandle, 'isc_detach_database');
  if @IscDetachDatabase = nil then
    raise Exception.Create('Failed to lookup isc_detach_database');

end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
 stat: isc_status;
 sv: status_vector;
begin
 if dbhandle <> nil then
   stat:=ISCDetachDatabase(@sv, @dbhandle);
 FreeLibrary(LibHandle);
end;

end.
